/* ---------------------------------------------------------- */
/*  tcgs_cave_2d.h                                            */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    cave retro version - game main
    @author   rerofumi
    @since    Nov.10.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef TCGS_CAVE_2D_H
#define TCGS_CAVE_2D_H

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

#define CHAR_WIDTH 22
#define CHAR_HEIGHT 23

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_opengl_app.h"

/**
 * @brief 2DAQ[
 *
 * @todo -
 * @bug -
 */
class Cave2dGame
{
  /* --- RXgN^EfXgN^ */
 public:
  Cave2dGame();
  Cave2dGame(PakoOpenglApp *parent);
  virtual  ~Cave2dGame();

  /* --- AvP[V\bh */
 public:
  void setParent(PakoOpenglApp *parent);
  int initalizeGame(void);
  int getState(void);
  bool tick(void);
  bool tickDisplay(void);

  /* --- [J[N */
 private:
  //! ĂяoeNX
  PakoOpenglApp *m_parent;
  //! Q[̐is
  int  m_nowPlaying;
  //! ASCII VRAM
  int  m_vram[CHAR_WIDTH*CHAR_HEIGHT];

  /* --- Q[p */
 public:
  //! game step
  int m_step;
  //! wait timer
  int m_wait;
  //! wait gameover
  int m_gameover_timer;
  //! score
  int m_score;
  //! hole position
  int m_hole_x;
  //! myship position
  int m_myship_x;

  //! Q[{
  bool  cave_game(void);
  //! XRA\
  void  display_score();

};

#endif
