/* ---------------------------------------------------------- */
/*  tcgs_cave_title.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    title select
    @author   rerofumi
    @since    Nov.11.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef TCGS_CAVE_TITLE_H
#define TCGS_CAVE_TITLE_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_opengl_app.h"

/**
 * @brief AQ[^Cg
 *
 * @todo -
 * @bug -
 */
class CaveTitle
{
  /* --- RXgN^EfXgN^ */
 public:
  CaveTitle();
  CaveTitle(PakoOpenglApp *parent);
  virtual  ~CaveTitle();

  /* --- AvP[V\bh */
 public:
  void setParent(PakoOpenglApp *parent);
  int initalizeGame(void);
  int getState(void);
  bool tick(void);
  bool tickDisplay(void);

  /* --- [J[N */
 private:
  //! ĂяoeNX
  PakoOpenglApp *m_parent;
  //! Q[̐is
  int  m_nowPlaying;
  //! wi\p̃^C}[
  float  m_dispTimer, m_dispTimer2, m_dispTimer3, m_dispTimer4;

  /* --- Q[p */
 public:
  //! Q[I
  int  m_select;
  //! J[\ړ^C}[
  int  m_selectMove;
  //! I_ŃEFCg
  int  m_selectAtruct;
  //! ItO
  bool m_selectDone;

};

#endif
